Bug 1315912 - Review Request: diffoscope - In-depth comparison of files, archives, and directories
Review Request: diffoscope - In-depth comparison of files, archives, and dire...
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Antonio Trande
Fedora Extras Quality Assurance
:
Depends On: 1315910 1316189
Blocks:
  Show dependency treegraph
 
Reported: 2016-03-08 19:40 EST by Zbigniew Jędrzejewski-Szmek
Modified: 2016-03-31 17:45 EDT (History)
3 users (show)

See Also:
Fixed In Version: diffoscope-51-3.fc22
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-03-31 17:45:48 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
anto.trande: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Zbigniew Jędrzejewski-Szmek 2016-03-08 19:40:07 EST
Spec URL: http://in.waw.pl/~zbyszek/fedora/diffoscope.spec
SRPM URL: http://in.waw.pl/~zbyszek/fedora/diffoscope-48-1.fc25.src.rpm
Fedora Account System Username: zbyszek
Description:
diffoscope will try to get to the bottom of what makes files or directories
different. It will recursively unpack archives of many kinds and transform
various binary formats into more human readable form to compare them. It can
compare two tarballs, ISO images, or PDF just as easily. The differences can
be shown in a text or HTML report.

diffoscope is developed as part of the "reproducible builds" Debian project and
was formerly known as "debbindiff".
Comment 1 Jonathan Underwood 2016-03-09 06:34:29 EST
You could replace many instances of "diffoscope" with %{name} in the spec file.
Comment 2 Zbigniew Jędrzejewski-Szmek 2016-03-09 06:40:53 EST
It seems I didn't update to the latest version, I need to do that first.

> You could replace many instances of "diffoscope" with %{name} in the spec file.
I think that reduces readability... and also copy&paste-ability.
Comment 3 Zbigniew Jędrzejewski-Szmek 2016-03-09 08:07:44 EST
Improved version:
- update to 51
- only one test disabled
- man page

Spec URL: http://in.waw.pl/~zbyszek/fedora/diffoscope.spec
SRPM URL: http://in.waw.pl/~zbyszek/fedora/diffoscope-51-1.fc25.src.rpm
Comment 4 Zbigniew Jędrzejewski-Szmek 2016-03-09 10:41:27 EST
More functionality with tlsh (#1316189). Works fine without, so I'm not adding a dependency yet.
Comment 5 Zbigniew Jędrzejewski-Szmek 2016-03-10 14:23:09 EST
Spec URL: http://in.waw.pl/~zbyszek/fedora/diffoscope.spec
SRPM URL: http://in.waw.pl/~zbyszek/fedora/diffoscope-51-2.fc25.src.rpm

Now with tlsh.
Comment 6 Antonio Trande 2016-03-10 14:35:39 EST
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Sources used to build the package match the upstream source, as provided
  in the spec URL.
  Note: Check did not completechecksum differs and there are problems
  running diff. Please verify manually.
  See: http://fedoraproject.org/wiki/Packaging/SourceURL

- Script installs python code released under GPLv3+ :

  GPL (v3 or later)
-----------------
diffoscope-51/bin/diffoscope
diffoscope-51/diffoscope/__init__.py
diffoscope-51/diffoscope/__main__.py
diffoscope-51/diffoscope/comparators/__init__.py
diffoscope-51/diffoscope/comparators/*.py

License tag should be modified to "BSD and GPLv3+"

- Diff spec file in url and in SRPM

- Please, check 

Source checksums
----------------
http://ftp.debian.org/debian/pool/main/d/diffoscope/diffoscope_51.tar.xz :
  CHECKSUM(SHA256) this package     : ERROR
  CHECKSUM(SHA256) upstream package : 48aecda84fd621649dd457b6ebe574ee2cf08a6eb475bdbc16284de195ea90dd


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "GPL (v3 or later)", "Unknown or
     generated". 70 files have unknown license. Detailed output of
     licensecheck in /home/sagitter/1315912-diffoscope/licensecheck.txt
[x]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/lib/python3.5/site-packages,
     /usr/lib/python3.5
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/python3.5/site-
     packages, /usr/lib/python3.5
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[ ]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see
     attached diff).
     See: (this test has no URL)
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: diffoscope-51-1.fc25.noarch.rpm
          diffoscope-51-1.fc25.src.rpm
diffoscope.noarch: W: spelling-error %description -l en_US debbindiff -> diffidence
diffoscope.src: W: spelling-error %description -l en_US debbindiff -> diffidence
diffoscope.src: W: invalid-url Source0: diffoscope-51.tar.xz
2 packages and 0 specfiles checked; 0 errors, 3 warnings.


Diff spec file in url and in SRPM
---------------------------------
--- /home/sagitter/1315912-diffoscope/srpm/diffoscope.spec	2016-03-10 19:15:46.706356273 +0100
+++ /home/sagitter/1315912-diffoscope/srpm-unpacked/diffoscope.spec	2016-03-09 14:10:10.000000000 +0100
@@ -1,9 +1,14 @@
 Name:          diffoscope
 Version:       51
-Release:       2%{?dist}
+Release:       1%{?dist}
 Summary:       In-depth comparison of files, archives, and directories
 License:       BSD
 URL:           https://diffoscope.org/
-Source0:       http://ftp.debian.org/debian/pool/main/d/diffoscope/diffoscope_%{version}.tar.xz
+#Source0:       https://pypi.python.org/packages/source/d/diffoscope/diffoscope-%%{version}.tar.gz
+
+# Latest versions missing from pypi
+# git clone https://anonscm.debian.org/git/reproducible/diffoscope.git
+# git archive --prefix diffoscope-51/ 51 | xz -9 > ../diffoscope-51.tar.xz
+Source0:       diffoscope-%{version}.tar.xz
 
 BuildArch:     noarch
@@ -18,5 +23,4 @@
 BuildRequires: /usr/bin/rst2man
 Requires:      python3-magic
-Requires:      python3-tlsh
 
 %description
@@ -60,7 +64,4 @@
 
 %changelog
-* Thu Mar 10 2016 Zbigniew Jędrzejewski-Szmek <zbyszek@bupkis> - 51-2
-- Require python3-tlsh
-
 * Wed Mar  9 2016 Zbigniew Jędrzejewski-Szmek <zbyszek@bupkis> - 51-1
 - Update to v 51


Requires
--------
diffoscope (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python(abi)
    python3-magic



Provides
--------
diffoscope:
    diffoscope



Source checksums
----------------
http://ftp.debian.org/debian/pool/main/d/diffoscope/diffoscope_51.tar.xz :
  CHECKSUM(SHA256) this package     : ERROR
  CHECKSUM(SHA256) upstream package : 48aecda84fd621649dd457b6ebe574ee2cf08a6eb475bdbc16284de195ea90dd


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 1315912
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 7 Zbigniew Jędrzejewski-Szmek 2016-03-10 16:52:11 EST
The license should just be GPLv3+, my bad. That's what the file headers and setup.py specifies.

Sorry for the mix-up with srpm and the spec file.

Spec URL: http://in.waw.pl/~zbyszek/fedora/diffoscope.spec
SRPM URL: http://in.waw.pl/~zbyszek/fedora/diffoscope-51-3.fc25.src.rpm
koji: http://koji.fedoraproject.org/koji/taskinfo?taskID=13300829
koji with the failing test enabled: http://koji.fedoraproject.org/koji/taskinfo?taskID=13300888

(It builds fine in mock, I hope it'll work in koji too.)
Comment 8 Antonio Trande 2016-03-11 06:58:25 EST
Package approved.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "GPL (v3 or later)", "Unknown or
     generated". 70 files have unknown license. Detailed output of
     licensecheck in /home/sagitter/1315912-diffoscope/licensecheck.txt
[x]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/lib/python3.5/site-packages,
     /usr/lib/python3.5
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/python3.5/site-
     packages, /usr/lib/python3.5
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[ ]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[ ]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: diffoscope-51-3.fc25.noarch.rpm
          diffoscope-51-3.fc25.src.rpm
diffoscope.noarch: W: spelling-error %description -l en_US debbindiff -> diffidence
diffoscope.src: W: spelling-error %description -l en_US debbindiff -> diffidence
2 packages and 0 specfiles checked; 0 errors, 2 warnings.




Rpmlint (installed packages)
----------------------------



Requires
--------
diffoscope (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python(abi)
    python3-magic
    python3-tlsh



Provides
--------
diffoscope:
    diffoscope



Source checksums
----------------
http://ftp.debian.org/debian/pool/main/d/diffoscope/diffoscope_51.tar.xz :
  CHECKSUM(SHA256) this package     : 48aecda84fd621649dd457b6ebe574ee2cf08a6eb475bdbc16284de195ea90dd
  CHECKSUM(SHA256) upstream package : 48aecda84fd621649dd457b6ebe574ee2cf08a6eb475bdbc16284de195ea90dd


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 1315912
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 9 Zbigniew Jędrzejewski-Szmek 2016-03-11 09:48:29 EST
Thanks!
Comment 10 Gwyn Ciesla 2016-03-11 11:11:51 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/diffoscope

Note You need to log in before you can comment on or make changes to this bug.